<!DOCTYPE html>
<html>
	<head>
		<meta charset="utf-8">
		<!-- Mobile Responsive Meta Tag -->
		<meta name="viewport" content="width=device-width, initial-scale=1">

	<!-- <link rel="stylesheet" href="index.css"> -->

		<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/css/bootstrap.min.css" integrity="sha384-zCbKRCUGaJDkqS1kPbPd7TveP5iyJE0EjAuZQTgFLD2ylzuqKfdKlfG/eSrtxUkn" crossorigin="anonymous">

		<title>CSS and Bootstrap Flex</title>
	</head>
	<body>
		<div class="container-fluid text-center">

		    <h1>Bootstrap Flex</h1>
		    <p>Use the d-flex class to create a flex container and transform direct children into flex items.</p>

		    <h2>Centering elements</h2>
		    <div style="height: 500px;" class="bg-secondary p-3 text-light d-flex justify-content-center align-items-center flex-column-reverse">
		        <div class="h-25 p-3 bg-success">Flex Item A</div>
		        <div class="h-25 p-3 bg-warning">Flex Item B</div>
		        <div class="h-25 p-3 bg-danger">Flex Item C</div>
		    </div>

		    <h2>Flex Row</h2>
		    <!-- 
		    	- flex-row property is default
				- flex-row-reverse - reverse the order and alignment (same with flex-column-reverse)
		     -->
		    <div class="bg-dark p-3 text-light d-flex flex-row-reverse">
		    	<div class="p-3 bg-success">Flex Item A</div>
		        <div class="p-3 bg-warning">Flex Item B</div>
		        <div class="p-3 bg-danger">Flex Item C</div>
		    </div>

		    <h2>Creating Space Between Elements</h2>
		    <!-- 
				- "justify-content-around" class center elements horizontally while creating space between elements and the border of its parent container
				- "justify-content-between" class center elements horizontally while creating space between each elements			
		     -->

		    <div class="bg-dark p-3 text-light d-md-flex justify-content-between">
		    	<div class="p-3 bg-success col-md-2">Flex Item A</div>
		        <div class="p-3 bg-warning col-md-2">Flex Item B</div>
		        <div class="p-3 bg-danger col-md-2">Flex Item C</div>
		    </div>

		    <h2>Flexbox with Margin</h2>
		    <div class="bg-dark p-5 text-light d-flex">
		    	<!-- values we can use to add to margin and padding: 0-5 and auto-->
		    	<!-- 
		    		"auto" class will occupy the remaining width of its parent container pushing all other elements inline
		    	 -->
		        <div class="p-3 bg-success mr-auto">Flex Item A</div>
		        <div class="p-3 bg-warning">Flex Item B</div>
		        <div class="p-3 bg-danger">Flex Item C</div>
		        <div class="p-3 bg-primary">Flex Item D</div>
		    </div>

		    <h2>Nested Flex Elements</h2>
		    <div class="bg-dark p-3 text-light d-block d-md-flex">
		    	<div class="p-3 bg-success mr-auto">Flex Item A</div>

		    	<!-- 
					- "d" classes only applies to its child elements and not to its grandchildren
					- This is the reason why multiple "d-flex" classes are needed in order to align elements in nested div
		    	 -->

		    	<div class="w-50 d-block d-md-flex justify-content-between">
		    		<div class="p-3 bg-warning"> Flex Item B</div>
		    		<div class="p-3 bg-danger"> Flex Item C</div>
		    		<div class="p-3 bg-primary"> Flex Item D</div>
		    	</div>
		    </div>
		    <!--
				JUSTIFY CONTENT CLASS
					- justify-content-start - align items to left (default)
					- justify-content-end - align items to right
					- justify-content-center - align items to center
					- justify-content-around

				ALIGN ITEMS CLASS (doesn't expand/stretch/occupy all space)
					- align-items-start - align items to top (default)
					- align-items-end - align items to bottom
					- align-items-center - align items to center
					- align-items-stretch - stretches the elments and occupies the overall height of parent container
		     -->
		     <!-- NOTE: row has "display:flex;" property -->
		     <!-- <h2>Centering elements</h2> -->
		     <!-- <div style="height: 500px;" class="bg-secondary p-3 text-light justify-content-center align-items-center row">
		        <div class="p-3 bg-success">Flex Item A</div>
		        <div class="p-3 bg-warning">Flex Item B</div>
		        <div class="p-3 bg-danger">Flex Item C</div>
		    </div> -->

		</div>
		<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
		<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.bundle.min.js" integrity="sha384-fQybjgWLrvvRgtW6bFlB7jaZrFsaBXjsOMm/tB9LTS58ONXgqbR9W8oWht/amnpF" crossorigin="anonymous"></script>
	</body>
</html>
